<template>
  <div class="white-block">
    <div class="padding">
      <h3>Информация о работе и доходе</h3>
    </div>
    <hr/>
    <div class="padding">
      <div class="row">
        <div class="columns four">
          <label for="typeOfEmployment">Вид занятости</label>
          <multiselect v-model="fieldTypeOfEmployment"
                       :options="typeOfEmploymentStatus"
                       :searchable="false"
                       :close-on-select="true"
                       :show-labels="false"
                       placeholder=""
                       :value="stirringLife"
                       id="typeOfEmployment"
                       :preserve-search="true"
                       label="title"
                       track-by="id"
                       @input="getTypeOfEmployment"
                       :vValidateRules = "'required'"
                       v-validate="'required'"
                       name="typeOfEmployment"
                       :class="getValidateClass('typeOfEmployment')"
                       data-code="typeOfEmploymentInvalidFormat, typeOfEmploymentNotInAvailableRange"
          >
          </multiselect>
          <validate-message v-show="vErrors.has('typeOfEmployment')">
            {{ vErrors.first('typeOfEmployment') }}
          </validate-message>
        </div>

        <div class="columns four">
          <label for="workSalary">Ежемесячный доход</label>
          <input type="tel"
                 name="workSalary"
                 id="workSalary"
                 maxlength="7"
                 :class="getValidateClass('workSalary')"
                 v-model="$user.workSalary"
                 v-validate="'required|min_value:2000|max_value:1000000'"
                 v-mask="'#######'"
                 autocomplete="off"
                 data-code="workSalaryInvalidFormat, workSalaryNotInAvailableRange"
          />
          <validate-message v-show="vErrors.has('workSalary')">
            {{ vErrors.first('workSalary') }}
          </validate-message>
        </div>

        <div v-if="$user.typeOfEmployment == 1" class="columns four">
          <label for="workType">Тип организации</label>
          <multiselect id="workType"
                       ref="workType"
                       name="workType"
                       v-model="workTypeStatus"
                       :options="fieldWorkType"
                       @input="getWorkTypeStatus"
                       :vValidateRules="'required'"
                       :searchable="false"
                       :close-on-select="true"
                       :value="typeOfOrganization"
                       :show-labels="false"
                       placeholder=""
                       :preserve-search="true"
                       label="title"
                       track-by="id"
                       v-validate="'required'"
                       :class="getValidateClass('workType')"
                       data-code="workTypeInvalidFormat, workTypeNotInAvailableRange"
          >
          </multiselect>

          <validate-message v-show="vErrors.has('workType')">
            {{ vErrors.first('workType') }}
          </validate-message>
        </div>

        <transition name="slide-fade">
          <founder-full-name v-if="$user.typeOfEmployment == 3" ref="FounderFullName"></founder-full-name>
        </transition>

      </div>

      <!--<transition name="slide-fade">-->
        <!--<div class="row" v-if="$user.typeOfEmployment == 2">-->
          <!--<businessman ref="businessman"></businessman>-->
        <!--</div>-->
      <!--</transition>-->

    </div>
    <transition name="slide-fade">
      <div v-if="$user.typeOfEmployment == 1">
        <employee ref="employee"></employee>
        <hr>
        <work-address ref="WorkAddress" :profile="false"></work-address>
      </div>
    </transition>
  </div>
</template>

<script>
  import Employee from './Employee'
  import Businessman from './Businessman'
  import FounderFullName from './FounderFullName'
  import WorkAddress from '@/components/User/Address'

  import Multiselect from '@/UI/Multiselect'
  import UserGetter from '@/mixins/User/UserGetterMixin'
  import UserSetter from '@/mixins/User/UserSetterMixin'
  import UserErrorText from '@/mixins/User/UserErrorTextMixin'
  import GetValidateClass from '@/mixins/Validation/GetValidateClassMixin'
  import ValidateMessage from '@/components/Validators/ValidateMessage'

  import IndicatorRegistration from '@/mixins/IndicatorRegistration'
  import { REQUIRED_FIELD, MIN_LENGHT } from '@/components/Validators/CustomVeeValidateMessage'
  import ErrorHandleMixin from '@/mixins/ErrorHandleMixin'

  export default {
    name: 'work-information',
    mixins: [
      UserGetter,
      UserSetter,
      UserErrorText,
      GetValidateClass,
      IndicatorRegistration,
      ErrorHandleMixin
    ],
    components: {
      Employee,
      Businessman,
      FounderFullName,
      WorkAddress,
      ValidateMessage,
      Multiselect
    },
    data () {
      return {
      	workTypeStatus: '',
        typeOfOrganization: '',
        fieldTypeOfEmployment: '',
        fieldWorkType: [
            {id: 1, title: 'Государственная'},
            {id: 2, title: 'Частная'}
        ],
        typeOfEmploymentStatus: [
          {id: 1, title: 'Наемный сотрудник'},
          {id: 2, title: 'Индивидуальный предприниматель'},
          {id: 3, title: 'Учредитель/участник ООО'},
          {id: 4, title: 'Пенсионер'},
          {id: 5, title: 'Студент'},
          {id: 6, title: 'Безработный'},
          {id: 7, title: 'Самозанятый'},
          {id: 8, title: 'Военнослужащий'}
        ]
      }
    },
    computed: {
        stirringLife () {
          this.fieldTypeOfEmployment = this.typeOfEmploymentStatus[this.$user.typeOfEmployment - 1]
        }
    },
    methods: {
		getWorkTypeStatus(workType) {
			this.$user.workType = workType.id;
		},
      getTypeOfEmployment (arg) {
        if (arg.id !== 1) {
          this.$user.workType = null
          this.$user.workScope = null
          this.$user.workName = null
          this.$user.workPhone = null
          this.$user.workNumberOfEmployees = null
          this.$user.workPeriod = null
          this.$user.workPosition = null
          let address = this.$user.workAddress
          let fiases = this.$user.workAddressFiases
          Object.keys(fiases).forEach(key => fiases[key] = null)
          Object.keys(address).forEach(key => address[key] = null)
          address.doNotHaveStreet = false
        }
        if (arg.id !== 2) {
          this.$user.workINN = null
        }
        if (arg.id !== 3) {
          this.$user.workINN = null
          this.$user.workFullName = null
        }
        this.$user.typeOfEmployment = arg.id
      }
    },
    created() {
		this.typeOfOrganization = this.workTypeStatus = this.fieldWorkType[this.$user.workType - 1];
    },
    mounted () {
      this.$validator.localize(REQUIRED_FIELD)
      this.$validator.localize(MIN_LENGHT)
    },
    updated () {
        this.$user.validate.step3.workInformation = Object.keys(this.$validator.flags).reduce((acc, item) => acc && this.$validator.flags[item].valid, true)
    },
  }
</script>

<style scoped lang="scss">
  .slide-fade-enter-active {
    transition: all .3s ease;
  }

  .slide-fade-leave-active {
    transition: all .3s ease;
  }

  .slide-fade-enter, .slide-fade-leave-to {
    transform: translateY(10px);
    opacity: 0;
  }

  .slide-fade-leave-to {
    transform: translateY(10px);
    opacity: 0
  }
</style>
